/* 

  ****************   NO WARRANTY  *****************

Since the Aspirin/MIGRAINES system is licensed free of charge,
Russell Leighton and the MITRE Corporation provide absolutley 
no warranty. Should the Aspirin/MIGRAINES system prove defective, 
you must assume the cost of all necessary servicing, repair or correction.
In no way will Russell Leighton or the MITRE Corporation be liable to you for
damages, including any lost profits, lost monies, or other
special, incidental or consequential damages arising out of
the use or inability to use the Aspirin/MIGRAINES system.

  *****************   COPYRIGHT  *******************

This software is the copyright of Russell Leighton and the MITRE Corporation. 
It may be freely used and modified for research and development
purposes. We require a brief acknowledgement in any research
paper or other publication where this software has made a significant
contribution. If you wish to use it for commercial gain you must contact 
The MITRE Corporation for conditions of use. Russell Leighton and 
the MITRE Corporation provide absolutely NO WARRANTY for this software.

   August, 1992 
   Russell Leighton
   The MITRE Corporation
   7525 Colshire Dr.
   McLean, Va. 22102-3481

*/
#include "analyze.h"

/* from analyze_eigen.c */
extern void save_target_values(char *file_prefix, int groups, int n_columns,
			       float *vector, int xdim, int ydim);

/* from analyze_veq.c */
extern int veq(float *v1, float *v2, int n, int mode);


void div_data(DATA_GROUP *g, char *file_prefix, int mode)
{
  char filename[256];
  int n_columns=df->inputs_size;
  int group_number=1;
  
  fprintf(stderr, "\n\tSpitting groups into flat files: %s.<number>", file_prefix);
  fprintf(stderr, "\n\twhere <number> is the group number.");
  
  /* for each group... */
  while (g != NULL) {
    DATAFILEPTR files = df->datafiles;
    FILE *fp;
    
    /*   -----------------------   open file   ----------------------- */
    sprintf(filename, "%s.%d", file_prefix, group_number);
    fp = am_fopen(filename, "w");
    if (fp == NULL) {
      fprintf(stderr, "\nUnable to open %s!\n", filename);
      am_perror("analyze");
    } else {
      fprintf(stderr, "\n\tGroup: %d", group_number);
    }/* end else if */
    
    /*   -----------------------   spit out data   ----------------------- */
    do {
      int n = files->npatterns;
      
      while (n--) {

	(*files->next_pattern)(files); /* ask file for next pattern */

	/* if the targets are the same then... */
	if ( veq(g->target_vector,
		 *(files->targets + files->current_pattern),
		 df->targets_size, mode) ) {
	  fwrite(*(files->inputs + files->current_pattern),
		 sizeof(float), n_columns,  fp);
	}/* end if */
      }/* end while */
      
      files = files->next;
    } while(files != df->datafiles) ; /* it's a circular list */
    
    /*   -----------------------   close file   ----------------------- */
    close(fp);
    
    /* save target file */
    save_target_values(file_prefix, group_number,
		       df->targets_size, g->target_vector,
		       df->targets_xdim, df->targets_ydim);
    
    g = g->next;
    group_number++;
    
  }/* end while */
  
  
  fprintf(stderr, "\n");
}
